#ifndef N_QUEENS_HPP_
#define N_QUEENS_HPP_

#include <sstream>
#include "array_queue.hpp"
#include "array_set.hpp"
#include "array_map.hpp"


namespace ics {


class Problem; //Forward reference for Problem* p;


class Aspect {
public:
  Aspect();
  Aspect(int row, Problem* prob);
  virtual ~Aspect();
  ics::ArrayQueue<int> choices      () const;
  std::string         assignment_to (int r) const;
  bool operator ==                  (const Aspect& rhs) const;
  friend std::ostream& operator <<  (std::ostream& outs, const Aspect& a);
private:
  int                  row_working_on;
  Problem*             problem;
  ics::ArrayQueue<int> ok_columns;
};



//KLUDGE:operator=?
class Problem {
public:
  Problem(int board_size);
  virtual ~Problem();
  Aspect                 choose_and_exclude_aspect ();
  ArrayMap<Aspect,int>  get_solution              () const;
  void                   assign_aspect_value       (Aspect aspect, int value);
  void                   remove_aspect_value       (Aspect aspect);
  Problem                copy () const;
  friend std::ostream& operator << (std::ostream& outs, const Problem& p);
  friend Aspect;
private:
  int                       max_n;
  ics::ArrayMap<Aspect,int> assignments;
};


}

#endif /* N_QUEENS_HPP_ */
