#ifndef SATISFY_HPP_
#define SATISFY_HPP_

#include "array_queue.hpp"
#include "array_set.hpp"
#include "array_map.hpp"
#include <initializer_list>


namespace ics {


//KLUDGE:operator=?
class Aspect {
public:
  Aspect();
  Aspect(std::string variable_name);
  virtual ~Aspect();
  std::string          variable_name () const;
  ics::ArrayQueue<bool> choices      () const;
  std::string          assignment_to (bool b) const;
  bool operator ==                   (const Aspect& rhs) const;
  friend std::ostream& operator <<   (std::ostream& outs, const Aspect& a);
private:
  std::string           variable;
  ics::ArrayQueue<bool> values{true,false}; //Form for initializers, since constructor is explicit
};


class Problem {
public:
  Problem(std::string formula_text, ics::ArraySet<std::string> variables, bool (*e)(ics::ArrayMap<std::string,bool> assignments));
  virtual ~Problem();
  Aspect                 choose_and_exclude_aspect ();
  ArrayMap<Aspect,bool>  get_solution              () const;
  void                   assign_aspect_value       (Aspect aspect, bool value);
  void                   remove_aspect_value       (Aspect aspect);
  Problem                copy () const;
  friend std::ostream& operator << (std::ostream& outs, const Problem& p);
private:
  std::string                formula;
  ics::ArraySet<std::string> variables;
  ics::ArrayMap<Aspect,bool> assignments;
  bool                       (*evaluate)(ics::ArrayMap<std::string,bool> assignments);
};


}

#endif /* SATISFY_HPP_ */
