//#include <string>
//#include <sstream>
//#include <stdio.h>
//#include <stdlib.h>        //For abs
//#include "sudoku.hpp"
//#include "backtrack_exceptions.hpp"
//
//
//namespace ics {
//
//std::string to_string(int x) {
//  std::ostringstream ss;
//  ss << x;
//  return ss.str();
//}
//
//Aspect::Aspect()
//  : row_working_on(-1), col_working_on(-1), problem(nullptr) {
//}
//
//
//Aspect::Aspect(int row, int col, const Problem* prob)
//  : row_working_on(row), col_working_on(col), problem(prob) {
//  for (int i = 1; i < 10; ++i)
//    ok_values.insert(i);
//  for (int c = 0; c < 9; c++)
//    ok_values.erase(prob->puzzle[row][c]);
//  for (int r = 0; r < 9; r++)
//    ok_values.erase(prob->puzzle[r][col]);
//  for (int r = row / 3 * 3; r < row / 3 * 3 + 3; r++)
//    for (int c = col / 3 * 3; c < col / 3 * 3 + 3; c++)
//      ok_values.erase(prob->puzzle[r][c]);
//}
//
//
//Aspect::~Aspect() {
//}
//
//int Aspect::row() const {
//  return row_working_on;
//}
//
//
//int Aspect::col() const {
//  return col_working_on;
//}
//
//
//ics::ArraySet<int> Aspect::choices () const {
//  return ok_values;
//}
//
//
//std::string Aspect::assignment_to(int v) const {
//  return "  On [" + to_string(row_working_on) + "," + to_string(col_working_on) + "] assign " + to_string(v);
//}
//
//
//bool Aspect::operator == (const Aspect& rhs) const {
//  if (this == &rhs)
//    return true;
//  return row_working_on == rhs.row_working_on &&
//         col_working_on == rhs.col_working_on;
//}
//
//
//std::ostream& operator << (std::ostream& outs, const Aspect& a) {
//  outs << "Sudoku.Aspect[row=" << a.row_working_on << ",col=" << a.col_working_on << "]";
//  return outs;
//}
//
//
//
//
//
//Problem::Problem(const int remaining_puzzle[][9]) {
//  for (int r = 0; r < 9; r++)
//    for (int c = 0; c < 9; c++)
//      puzzle[r][c] = remaining_puzzle[r][c];
//}
//
//
//Problem::~Problem() {
//}
//
//
//Aspect Problem::choose_and_exclude_aspect () {
//  for (int r = 0; r < 9; r++)
//    for (int c = 0; c < 9; c++)
//      if (puzzle[r][c] == 0)
//        return Aspect(r, c, this);
//
//  //No aspects left!
//  throw BacktrackSucceed();
//}
//
//
//ArrayMap<Aspect,int> Problem::get_solution () const {
//  ics::ArrayMap<Aspect,int> answer;
//  for (int r = 0; r < 9; r++)
//    for (int c = 0; c < 9; c++)
//      answer[Aspect(r,c,this)] = puzzle[r][c];
//
//  return answer;
//}
//
//
//void Problem::assign_aspect_value (Aspect aspect, int value) {
//  puzzle[aspect.row_working_on][aspect.col_working_on] = value;
//}
//
//
//void Problem::remove_aspect_value (Aspect aspect) {
//  puzzle[aspect.row_working_on][aspect.col_working_on] = 0;
//}
//
//
//Problem Problem::copy () const {
//  return Problem(puzzle);
//}
//
//std::ostream& operator << (std::ostream& outs, const Problem& p) {
//  outs <<  "Sudoku[" << std::endl;
//  for (int r = 0; r < 9; r++) {
//    for (int c = 0; c < 9; c++)
//      printf("%2d", p.puzzle[r][c]);
//    printf("\n");
//  }
//  printf("]");
//  return outs;
//}
//
//}
//
