#ifndef SUDOKU_HPP_
#define SUDOKU_HPP_


#include "array_set.hpp"
#include "array_map.hpp"


//KLUDGE: why array const, and const Problem*?


namespace ics {


class Problem; //Forward reference for Problem* p;


class Aspect {
public:
  Aspect();
  Aspect(int row, int col, const Problem* prob);
  virtual ~Aspect();
  int                 row           () const;
  int                 col           () const;
  ics::ArraySet<int>  choices       () const;
  std::string         assignment_to (int r) const;
  bool operator ==                  (const Aspect& rhs) const;
  friend std::ostream& operator <<  (std::ostream& outs, const Aspect& a);
  friend Problem;
private:
  int                row_working_on;
  int                col_working_on;
  const Problem*     problem;
  ics::ArraySet<int> ok_values;
};



//KLUDGE:operator=?
class Problem {
public:
  Problem(const int initial_puzzle[][9]);
  virtual ~Problem();
  Aspect                 choose_and_exclude_aspect ();
  ArrayMap<Aspect,int>   get_solution              () const;
  void                   assign_aspect_value       (Aspect aspect, int value);
  void                   remove_aspect_value       (Aspect aspect);
  Problem                copy                      () const;
  friend std::ostream& operator <<                 (std::ostream& outs, const Problem& p);
  friend Aspect;
private:
  int puzzle[9][9];
};


}


#endif /* SUDOKU_HPP_ */
